import matplotlib.pyplot as plt

# sample points
X = []
Y = []

data = open('data.txt', 'r')

datum = data.readlines()

for i in datum:
    datapoint = list(eval(i))
    X.append(datapoint[0])
    Y.append(datapoint[1])

data.close()


# solve for a and b
def best_fit(X, Y):

    xbar = sum(X) / len(X)
    ybar = sum(Y) / len(Y)
    n = len(X)  # or len(Y)

    numer = sum([xi * yi for xi, yi in zip(X, Y)]) - n * xbar * ybar
    denum = sum([xi**2 for xi in X]) - n * xbar**2

    b = numer / denum
    a = ybar - b * xbar

    print('best fit line:\ny = {:.2f} + {:.2f}x'.format(a, b))

    return a, b


a, b = best_fit(X, Y)


plt.xlim(-300, 100)
plt.ylim(0, 1.5)

plt.xlabel('Time/s')
plt.ylabel('Temperature/K')

plt.scatter(X, Y)
yfit = [a + b * xi for xi in X]
plt.plot(X, yfit, 'k-')
plt.grid()
plt.show()
